Subject: Re: [RFC 1/2] netmap: infrastructure (in staging)

From: Stephen Hemminger <[email-masked]>
Date: Fri, 19 Apr 2013 13:16:32 -0700

On Fri, 19 Apr 2013 15:58:59 -0400 (EDT)
David Miller <[email-masked]> wrote:

> From: Greg KH <[email-masked]>
> Date: Fri, 19 Apr 2013 12:45:37 -0700
> 
> > On Fri, Apr 19, 2013 at 12:06:51PM -0700, Stephen Hemminger wrote:
> >> Netmap is a framework for packet generation and capture from user
> >> space. It allows for efficient packet handling (up to line rate on
> >> 10Gb) with minimum system load.  For more info see:
> >> 	http://info.iet.unipi.it/~luigi/netmap/
> 
> So are you saying that people can't get line rate today?
> 
> Even the the suricata folks are doing deep packet inspection at line
> rate using AF_PACKET fanouts just fine.  That means they aren't just
> grabbing packets, they are actually processing them and making
> stateful decisions based upon the packet's contents.
> 
> That means that capture is cheap enough already that they have all
> the compute left over that they need.
> 
> The existing mechanisms also have the huge advantage that they are
> already implemented, require zero driver specific changes, and are
> already starting to be deployed to end users.
> 
> Given that and how incredibly gross this code is right now, the only
> reaction I can have is "meh".
> 
> If you are going to propose something, please show a real and genuine
> need.

I can not get line rate output with pktgen on existing kernels today.
I can get line rate easily with netmap.